<TeXmacs|1.0.7.20>

<style|<tuple|beamer|mathemagix|vdh>>

<\body>
  <screens|<\shown>
    <\with|par-mode|center>
      <space|0cm|0cm|2.5fn><strong|<with|font-base-size|17|Introduction to
      <anim-repeat|<anim-compose|<anim-constant|M<very-small|<space|-0.2spc>A<space|-0.2spc>THEMAGIX>|2sec>|<anim-constant|<phantom|M><very-small|<space|-0.2spc><phantom|A<space|-0.2spc>THE>MAGIX>|1sec>|<anim-constant|<phantom|M><phantom|><very-small|<space|-0.2spc><phantom|A<space|-0.2spc>THE>MA<phantom|GI>X>|1sec>>>>><vspace|0.5fn>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|Joris van der Hoeven, Grgoire Lecerf, Bernard Mourrain,
      ...>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|Luminy
      2010>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<TeXmacs*>.org>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-progressive|<with|color|dark
      green|math>e<phantom|magix>|2sec|<tuple|0.0|0.0|0.0|1.0>|>|<anim-constant|<with|color|dark
      green|math>e<with|color|dark magenta|magix>|2sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Overview>

    \;

    <\itemize>
      <unroll|<\shown>
        <with|color|red|<strong|<item>Aims>>

        <\itemize>
          <item>Strongly typed language with a compiler.

          <item>Access to low level details and powerful abstractions.

          <item>Well integrated with other languages, such as C++.

          <item>Libraries for computer algebra and computer analysis.

          <item>User friendly interface based on GNU <TeXmacs>.
        </itemize>
      </shown>|<\hidden*>
        \;

        <with|color|red|<strong|<item>Current status>>

        <\itemize>
          <item>Interpreter with inperfect typing.

          <item>Experimental compiler under development.

          <item>Efficient C++ libraries for computer algebra and analysis.
        </itemize>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Running the interpreter>

    <\small>
      <\session|mathemagix|default>
        <\input>
          <mmx-prompt|1>
        <|input>
          1 + 1
        </input>

        <\input>
          <mmx-prompt|2>
        <|input>
          "Hello" \<gtr\>\<less\> "There"
        </input>

        <\input>
          <mmx-prompt|3>
        <|input>
          for i in 1 to 5 do mmout \<less\>\<less\> i \<less\>\<less\> "
          -\<gtr\> " \<less\>\<less\> i*i \<less\>\<less\> "\\n";
        </input>

        <\input>
          <mmx-prompt|4>
        <|input>
          type_mode? := true;
        </input>

        <\input>
          <mmx-prompt|5>
        <|input>
          1 + 1
        </input>

        <\input>
          <mmx-prompt|6>
        <|input>
          use "algebramix";
        </input>

        <\input>
          <mmx-prompt|7>
        <|input>
          1 + 1
        </input>

        <\input>
          <mmx-prompt|8>
        <|input>
          z == series (0, 1)
        </input>

        <\input>
          <mmx-prompt|9>
        <|input>
          sin z
        </input>

        <\input>
          <mmx-prompt|10>
        <|input>
          help series
        </input>

        <\input>
          <mmx-prompt|11>
        <|input>
          help Series Rational
        </input>

        <\input>
          <mmx-prompt|12>
        <|input>
          \;
        </input>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Running the compiler>

    <\smaller>
      <\session|shell|default>
        <\folded>
          Hello world
        <|folded>
          <\input|Shell] >
            mmc
          </input>

          <\input|Shell] >
            cat <hlink|hello.mmx|hello.mmx>
          </input>

          <\input|Shell] >
            mmc hello.mmx
          </input>

          <\input|Shell] >
            ./hello
          </input>

          <\input|Shell] >
            \;
          </input>
        </folded>

        <\folded>
          Separate compilation
        <|folded>
          <\input|Shell] >
            mmc --clean-cache
          </input>

          <\input|Shell] >
            cat <hlink|slave.mmx|slave.mmx>
          </input>

          <\input|Shell] >
            cat <hlink|master.mmx|master.mmx>
          </input>

          <\input|Shell] >
            mmc --verbose master.mmx
          </input>

          <\input|Shell] >
            ./master
          </input>

          <\input|Shell] >
            mmc --verbose master.mmx
          </input>

          <\input|Shell] >
            touch slave.mmx
          </input>

          <\input|Shell] >
            touch master.mmx
          </input>

          <\input|Shell] >
            \;
          </input>
        </folded>
      </session>
    </smaller>
  </hidden>|<\hidden>
    <tit|Atomic types>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          Booleans
        <|folded>
          <\input>
            <mmx-prompt|12>
          <|input>
            type_mode? := true;
          </input>

          <\input>
            <mmx-prompt|13>
          <|input>
            2 = 2
          </input>

          <\input>
            <mmx-prompt|14>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Strings
        <|folded>
          <\input>
            <mmx-prompt|14>
          <|input>
            "ho" \<gtr\>\<less\> "ho"
          </input>

          <\input>
            <mmx-prompt|15>
          <|input>
            replace ("hoho", "ho", "haha")
          </input>

          <\input>
            <mmx-prompt|16>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Syntactic types
        <|folded>
          <\input>
            <mmx-prompt|16>
          <|input>
            'x
          </input>

          <\input>
            <mmx-prompt|17>
          <|input>
            '(f (x, y, z))
          </input>

          <\input>
            <mmx-prompt|18>
          <|input>
            '(f (x, y, z)) [2]
          </input>

          <\input>
            <mmx-prompt|19>
          <|input>
            $document ("Some ", $with ("color", "red", "red"), " text.";

            \ \ \ \ \ \ \ \ \ \ \ "Pythagoras said ", $math ('(a^2 + b^2 =
            c^2)), ".")
          </input>

          <\input>
            <mmx-prompt|20>
          <|input>
            mmout \<less\>\<less\> $document ("More ", $strong ("very
            important"), " stuff.") \<less\>\<less\> "\\n";
          </input>

          <\input>
            <mmx-prompt|21>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Ports
        <|folded>
          <\input>
            <mmx-prompt|21>
          <|input>
            mmout
          </input>

          <\input>
            <mmx-prompt|22>
          <|input>
            mmout \<less\>\<less\> "Hello\\n";
          </input>

          <\input>
            <mmx-prompt|23>
          <|input>
            output_file_port ("toto.txt") \<less\>\<less\> "Hi there\\n";
          </input>

          <\input>
            <mmx-prompt|24>
          <|input>
            load ("toto.txt")
          </input>

          <\input>
            <mmx-prompt|25>
          <|input>
            \;
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Numeric types>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          Integers
        <|folded>
          <\input>
            <mmx-prompt|25>
          <|input>
            use "numerix";
          </input>

          <\input>
            <mmx-prompt|26>
          <|input>
            100!
          </input>

          <\input>
            <mmx-prompt|27>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Rational numbers
        <|folded>
          <\input>
            <mmx-prompt|27>
          <|input>
            1/1 + 1/2 + 1/3 + 1/4 + 1/5 + 1/6 + 1/7 + 1/8 + 1/9 + 1/10
          </input>

          <\input>
            <mmx-prompt|28>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Floating point numbers
        <|folded>
          <\input>
            <mmx-prompt|28>
          <|input>
            exp 1.0
          </input>

          <\input>
            <mmx-prompt|29>
          <|input>
            bit_precision := 128;
          </input>

          <\input>
            <mmx-prompt|30>
          <|input>
            exp 1.0
          </input>

          <\input>
            <mmx-prompt|33>
          <|input>
            significant_digits := 5
          </input>

          <\input>
            <mmx-prompt|34>
          <|input>
            exp 1.0
          </input>

          <\input>
            <mmx-prompt|35>
          <|input>
            exp 1.0000000000000000000000001 - exp 1.0
          </input>

          <\input>
            <mmx-prompt|36>
          <|input>
            significant_digits := 0
          </input>

          <\input>
            <mmx-prompt|37>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Complex numbers
        <|folded>
          <\input>
            <mmx-prompt|37>
          <|input>
            complex (1, 2/3)
          </input>

          <\input>
            <mmx-prompt|38>
          <|input>
            square complex (1, 2/3)
          </input>

          <\input>
            <mmx-prompt|39>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Tangent numbers
        <|folded>
          <\input>
            <mmx-prompt|39>
          <|input>
            tangent (1, 2)
          </input>

          <\input>
            <mmx-prompt|40>
          <|input>
            tangent (1, 2) * tangent (1, 2)
          </input>

          <\input>
            <mmx-prompt|41>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Balls
        <|folded>
          <\input>
            <mmx-prompt|41>
          <|input>
            b == ball (1.0, 0.00000000001)
          </input>

          <\input>
            <mmx-prompt|42>
          <|input>
            1.0001 * b - b
          </input>

          <\input>
            <mmx-prompt|43>
          <|input>
            \;
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Compound types and syntactic sugar>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          Vectors
        <|folded>
          <\input>
            <mmx-prompt|43>
          <|input>
            use "algebramix";
          </input>

          <\input>
            <mmx-prompt|44>
          <|input>
            v == [1, 2, 3, 4, 5, 6]
          </input>

          <\input>
            <mmx-prompt|45>
          <|input>
            v \<gtr\>\<less\> map (square, v)
          </input>

          <\input>
            <mmx-prompt|46>
          <|input>
            v*v + 3*v + 2
          </input>

          <\input>
            <mmx-prompt|47>
          <|input>
            #v
          </input>

          <\input>
            <mmx-prompt|48>
          <|input>
            v[1]
          </input>

          <\input>
            <mmx-prompt|49>
          <|input>
            v[2,4]
          </input>

          <\input>
            <mmx-prompt|50>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Iterators and syntactic sugar
        <|folded>
          <\input>
            <mmx-prompt|50>
          <|input>
            1 to 10
          </input>

          <\input>
            <mmx-prompt|51>
          <|input>
            [ 1 to 10 ]
          </input>

          <\input>
            <mmx-prompt|52>
          <|input>
            [ 0..10 ]
          </input>

          <\input>
            <mmx-prompt|53>
          <|input>
            [ k^3 \| k in 1 to 10 ]
          </input>

          <\input>
            <mmx-prompt|54>
          <|input>
            [ k^3 \| k in 1 to 10, k mod 3 = 1 ]
          </input>

          <\input>
            <mmx-prompt|55>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Matrices
        <|folded>
          <\input>
            <mmx-prompt|55>
          <|input>
            [ 1, 2; 3, 4 ]
          </input>

          <\input>
            <mmx-prompt|56>
          <|input>
            M == [ 1 / (i+j+1) \| j in 0..4 \|\| i in 0..4 ]
          </input>

          <\input>
            <mmx-prompt|57>
          <|input>
            invert M
          </input>

          <\input>
            <mmx-prompt|58>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Tables
        <|folded>
          <\input>
            <mmx-prompt|58>
          <|input>
            t := table (0)
          </input>

          <\input>
            <mmx-prompt|59>
          <|input>
            t['x]
          </input>

          <\input>
            <mmx-prompt|60>
          <|input>
            t['x] := "Hallo";
          </input>

          <\input>
            <mmx-prompt|61>
          <|input>
            t
          </input>

          <\input>
            <mmx-prompt|62>
          <|input>
            t['x]
          </input>

          <\input>
            <mmx-prompt|63>
          <|input>
            t[polynomial(1,1)^10] := "Boeh";
          </input>

          <\input>
            <mmx-prompt|64>
          <|input>
            t
          </input>

          <\input>
            <mmx-prompt|65>
          <|input>
            \;
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Simple declarations>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          Constant and mutable variables
        <|folded>
          <\input>
            <mmx-prompt|65>
          <|input>
            cst: Integer == 111111111^2
          </input>

          <\input>
            <mmx-prompt|66>
          <|input>
            mut: Integer := 1010101010101010101010101010101^2
          </input>

          <\input>
            <mmx-prompt|67>
          <|input>
            cst := square cst
          </input>

          <\input>
            <mmx-prompt|68>
          <|input>
            mut := square mut
          </input>

          <\input>
            <mmx-prompt|69>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Function definitions and overloading
        <|folded>
          <\input>
            <mmx-prompt|69>
          <|input>
            cube (x: Integer): Integer == x*x*x;
          </input>

          <\input>
            <mmx-prompt|70>
          <|input>
            cube (s: String): String == s \<gtr\>\<less\> s \<gtr\>\<less\>
            s;
          </input>

          <\input>
            <mmx-prompt|71>
          <|input>
            cube 1001001001001001
          </input>

          <\input>
            <mmx-prompt|72>
          <|input>
            cube "haha"
          </input>

          <\input>
            <mmx-prompt|73>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          The generic type
        <|folded>
          <textput|Disclaimer: special arithmetic on generic
          object<vspace|0.5fn>s only available in interpreter.>

          <\input>
            <mmx-prompt|73>
          <|input>
            haha (ha) == ha * ha;
          </input>

          <\input>
            <mmx-prompt|74>
          <|input>
            haha 1111
          </input>

          <\input>
            <mmx-prompt|75>
          <|input>
            infix * (s1: String, s2: String): String == s1 \<gtr\>\<less\>
            s2;
          </input>

          <\input>
            <mmx-prompt|76>
          <|input>
            haha "ahah"
          </input>

          <\input>
            <mmx-prompt|77>
          <|input>
            haha (ha: Integer) == ha * ha * ha * ha;
          </input>

          <\input>
            <mmx-prompt|78>
          <|input>
            haha 2
          </input>

          <\input>
            <mmx-prompt|79>
          <|input>
            haha "ohoh"
          </input>

          <\input>
            <mmx-prompt|80>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Functional programming
        <|folded>
          <\input>
            <mmx-prompt|80>
          <|input>
            fib (n: Integer): Integer ==

            \ \ if n \<less\>= 1 then 1 else fib (n-1) + fib (n-2);
          </input>

          <\input>
            <mmx-prompt|81>
          <|input>
            [ fib n \| n in 1 to 20 ]
          </input>

          <\input>
            <mmx-prompt|82>
          <|input>
            shift (x: Integer) (y: Integer): Integer == x + y;
          </input>

          <\input>
            <mmx-prompt|83>
          <|input>
            shift 3
          </input>

          <\input>
            <mmx-prompt|84>
          <|input>
            (shift 3) 4
          </input>

          <\input>
            <mmx-prompt|85>
          <|input>
            map (shift 3, [ 1 to 20 ])
          </input>

          <\input>
            <mmx-prompt|86>
          <|input>
            \;
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Class definitions>

    <\small>
      <\session|mathemagix|default>
        <\input>
          <mmx-prompt|86>
        <|input>
          use "numerix"; type_mode? := true; significant_digits := 5;
        </input>

        <\input>
          <mmx-prompt|87>
        <|input>
          class Color == {

          \ \ mutable { r: Floating; g: Floating; b: Floating; }

          \ \ constructor grey (x: Floating) == {

          \ \ \ \ r == x; g == x; b == x; }

          \ \ constructor rgb (r2: Floating, g2: Floating, b2: Floating) == {

          \ \ \ \ r == r2; g == g2; b == b2; }

          }
        </input>

        <\input>
          <mmx-prompt|88>
        <|input>
          rgb (1, 0, 0)
        </input>

        <\input>
          <mmx-prompt|89>
        <|input>
          flatten (c: Color): Syntactic ==

          \ \ syntactic ('rgb (as_generic flatten c.r,

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ as_generic flatten c.g,

          \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ as_generic flatten c.b));
        </input>

        <\input>
          <mmx-prompt|90>
        <|input>
          rgb (1, 0, 0)
        </input>

        <\input>
          <mmx-prompt|91>
        <|input>
          mix (c1: Color, c2: Color, a: Floating): Color ==

          \ \ rgb (a * c1.r + (1-a) * c2.r,

          \ \ \ \ \ \ \ a * c1.g + (1-a) * c2.g,

          \ \ \ \ \ \ \ a * c1.b + (1-a) * c2.b);
        </input>

        <\input>
          <mmx-prompt|92>
        <|input>
          mix (rgb (1, 0, 0), grey (0.5), 0.5)
        </input>

        <\input>
          <mmx-prompt|93>
        <|input>
          \;
        </input>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Implicit type conversion and inheritance>

    <\small>
      <\session|mathemagix|default>
        <\input>
          <mmx-prompt|93>
        <|input>
          upgrade (x: Floating): Color == grey x;
        </input>

        <\input>
          <mmx-prompt|94>
        <|input>
          mix (1.0, rgb (0, 1, 0), 0.2)
        </input>

        <\input>
          <mmx-prompt|95>
        <|input>
          mix (1, rgb (0, 1, 0), 0.4)
        </input>

        <\input>
          <mmx-prompt|96>
        <|input>
          class Alpha_color == {

          \ \ mutable { c: Color; a: Floating; }

          \ \ constructor alpha_color (c2: Color, a2: Floating) == { c == c2;
          a == a2; }

          };
        </input>

        <\input>
          <mmx-prompt|97>
        <|input>
          alpha_color (0, 0.5)
        </input>

        <\input>
          <mmx-prompt|98>
        <|input>
          downgrade (ac: Alpha_color): Color == mix (ac.c, 1, ac.a);
        </input>

        <\input>
          <mmx-prompt|99>
        <|input>
          alpha_color (0, 0.5) :\<gtr\> Color
        </input>

        <\input>
          <mmx-prompt|100>
        <|input>
          postfix .greyed (c: Color): Color == (c.r + c.g + c.b) / 3;
        </input>

        <\input>
          <mmx-prompt|101>
        <|input>
          rgb (1, 0, 0).greyed
        </input>

        <\input>
          <mmx-prompt|102>
        <|input>
          \;
        </input>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Control structures>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          Loops
        <|folded>
          <\input>
            <mmx-prompt|102>
          <|input>
            for i in [ 1, 4, 7] for j in [ 3, 5, 11 ] do

            \ \ mmout \<less\>\<less\> i \<less\>\<less\> ", "
            \<less\>\<less\> j \<less\>\<less\> " -\<gtr\> " \<less\>\<less\>
            i * j \<less\>\<less\> "\\n";
          </input>

          <\input>
            <mmx-prompt|103>
          <|input>
            for i: Int in 0..100 until i*i \<gtr\>= 5000 do {

            \ \ if i mod 11 \<less\>= 8 then continue;

            \ \ mmout \<less\>\<less\> "i= " \<less\>\<less\> i
            \<less\>\<less\> "\\n";

            }
          </input>

          <\input>
            <mmx-prompt|104>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          Exceptions
        <|folded>
          <\input>
            <mmx-prompt|104>
          <|input>
            risky (x: Rational): Rational == {

            \ \ if x = 5 then raise "not in domain";

            \ \ return 1 / (x - 5);

            }

            try {

            \ \ for i in 1 to 10 do mmout \<less\>\<less\> i \<less\>\<less\>
            " -\<gtr\> " \<less\>\<less\> risky i \<less\>\<less\> "\\n";

            \ \ catch (err: String) { mmout \<less\>\<less\> "error: "
            \<less\>\<less\> err \<less\>\<less\> "\\n"; }

            };
          </input>

          <\input>
            <mmx-prompt|105>
          <|input>
            \;
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Categories>

    <\smaller>
      <\mmx-code>
        <include|/Users/vdhoeven/seminar/Auron/ring.mmx>
      </mmx-code>

      \;

      <\session|shell|default>
        <\input|Shell] >
          mmc --verbose <hlink|--keep|ring.cpp> ring.mmx
        </input>

        <\input|Shell] >
          ./ring
        </input>

        <\input|Shell] >
          \;
        </input>
      </session>
    </smaller>
  </hidden>|<\hidden>
    <tit|Functional programming>

    <\smaller>
      <\mmx-code>
        <include|/Users/vdhoeven/seminar/Auron/recursive.mmx>
      </mmx-code>

      <\session|shell|default>
        <\input|Shell] >
          mmc --verbose <hlink|--keep|recursive.cpp> recursive.mmx
        </input>

        <\input|Shell] >
          ./recursive
        </input>

        <\input|Shell] >
          \;
        </input>
      </session>
    </smaller>
  </hidden>|<\hidden>
    <tit|Gluing <hlink|C++ functionality|~/mathemagix/mmx/numerix/mmx/integer.mmx>>

    <\smaller>
      <\mmx-code>
        <include|/Users/vdhoeven/seminar/Auron/syracuse.mmx>
      </mmx-code>

      <\session|shell|default>
        <\input|Shell] >
          mmc --verbose syracuse.mmx
        </input>

        <\input|Shell] >
          ./syracuse
        </input>

        <\input|Shell] >
          \;
        </input>
      </session>
    </smaller>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|none>
    <associate|page-bot|5mm>
    <associate|page-even|5mm>
    <associate|page-odd|5mm>
    <associate|page-right|5mm>
    <associate|page-screen-bot|5mm>
    <associate|page-screen-top|5mm>
    <associate|page-show-hf|true>
    <associate|page-top|5mm>
    <associate|preamble|false>
    <associate|sfactor|4>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|10|?>>
    <associate|auto-11|<tuple|11|?>>
    <associate|auto-12|<tuple|12|?>>
    <associate|auto-13|<tuple|13|?>>
    <associate|auto-14|<tuple|14|?>>
    <associate|auto-15|<tuple|15|?>>
    <associate|auto-16|<tuple|16|?>>
    <associate|auto-17|<tuple|17|?>>
    <associate|auto-18|<tuple|18|?>>
    <associate|auto-19|<tuple|19|?>>
    <associate|auto-2|<tuple|2|?>>
    <associate|auto-20|<tuple|20|?>>
    <associate|auto-3|<tuple|3|?>>
    <associate|auto-4|<tuple|4|?>>
    <associate|auto-5|<tuple|5|?>>
    <associate|auto-6|<tuple|6|?>>
    <associate|auto-7|<tuple|7|?>>
    <associate|auto-8|<tuple|8|?>>
    <associate|auto-9|<tuple|9|?>>
    <associate|cross-rel|<tuple|1|?>>
    <associate|eq-fonc|<tuple|1|15>>
    <associate|mv-th|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|toc-1|<tuple|<uninit>|2>>
    <associate|toc-10|<tuple|2|5>>
    <associate|toc-11|<tuple|2|5>>
    <associate|toc-12|<tuple|2|5>>
    <associate|toc-13|<tuple|2|5>>
    <associate|toc-14|<tuple|2|6>>
    <associate|toc-15|<tuple|2|6>>
    <associate|toc-16|<tuple|2|6>>
    <associate|toc-17|<tuple|2|7>>
    <associate|toc-18|<tuple|2|7>>
    <associate|toc-19|<tuple|2|7>>
    <associate|toc-2|<tuple|<uninit>|3>>
    <associate|toc-20|<tuple|2|7>>
    <associate|toc-21|<tuple|2|8>>
    <associate|toc-22|<tuple|2|8>>
    <associate|toc-23|<tuple|2|8>>
    <associate|toc-24|<tuple|2|8>>
    <associate|toc-25|<tuple|2|8>>
    <associate|toc-26|<tuple|2|8>>
    <associate|toc-27|<tuple|2|9>>
    <associate|toc-28|<tuple|2|9>>
    <associate|toc-29|<tuple|2|9>>
    <associate|toc-3|<tuple|<uninit>|3>>
    <associate|toc-30|<tuple|2|10>>
    <associate|toc-31|<tuple|2|10>>
    <associate|toc-32|<tuple|2|10>>
    <associate|toc-33|<tuple|2|11>>
    <associate|toc-34|<tuple|2|12>>
    <associate|toc-35|<tuple|2|13>>
    <associate|toc-36|<tuple|2|14>>
    <associate|toc-37|<tuple|2|14>>
    <associate|toc-38|<tuple|2|14>>
    <associate|toc-39|<tuple|2|15>>
    <associate|toc-4|<tuple|<uninit>|3>>
    <associate|toc-40|<tuple|2|15>>
    <associate|toc-41|<tuple|2|15>>
    <associate|toc-42|<tuple|2|15>>
    <associate|toc-43|<tuple|2|16>>
    <associate|toc-44|<tuple|2|16>>
    <associate|toc-45|<tuple|2|16>>
    <associate|toc-46|<tuple|2|17>>
    <associate|toc-47|<tuple|2|17>>
    <associate|toc-48|<tuple|2|17>>
    <associate|toc-49|<tuple|2|17>>
    <associate|toc-5|<tuple|<uninit>|3>>
    <associate|toc-50|<tuple|2|?>>
    <associate|toc-6|<tuple|<uninit>|4>>
    <associate|toc-7|<tuple|<uninit>|4>>
    <associate|toc-8|<tuple|2|4>>
    <associate|toc-9|<tuple|2|4>>
  </collection>
</references>